package nccloud.web.hrhi.psndoc.action;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.logging.Logger;
import nc.vo.pub.BusinessException;
import nc.vo.uif2.LoginContext;
import nccloud.base.exception.ExceptionUtils;
import nccloud.commons.lang.ArrayUtils;
import nccloud.framework.core.io.WebFile;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.container.SessionContext;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.hrhi.psndoc.vo.ImportBean;
import nccloud.web.hrhi.psndoc.vo.ImportHead;
import nccloud.web.hrhi.psndoc.vo.TrainPsndocXlsImport;
import nccloud.web.uapbd.commons.web.ParamUtils;

public class TrainImportAction implements ICommonAction {

	@Override
	public Object doAction(IRequest request) {
		WebFile[] webfiles = request.readFiles();
	    if (ArrayUtils.isEmpty(webfiles)) {
	    	ExceptionUtils.wrapBusinessException("ϴļΪ");
	    }
	    ParamUtils param = new ParamUtils(request);
        LoginContext context = HRNccUtils.getLoginContext(param);
	    List<Map<String, Object>> headList = ImportHead.getHead();
	    String pk_group = context.getPk_group();
	    String pk_org = context.getPk_org();
	    ImportBean datas = null;
	    try {
	        TrainPsndocXlsImport importer = new TrainPsndocXlsImport();
	        String pk_loginUser = SessionContext.getInstance().getClientInfo().getUserid();
	        datas = importer.importFormFile(webfiles[0].getInputStream(), headList, webfiles[0].getFileName(), pk_group, pk_org, pk_loginUser);
	      }
	      catch (BusinessException e) {
	        Logger.error(e.getMessage(), e);
	      } 
	    
	    
	    Map<String, Object> map = new HashMap<String, Object>();
	    if (datas != null && datas.isError()) {
	      map.put("isSuccess", "Y");
	      map.put("datas", datas.getVector());
	      map.put("head", datas.getHeadVector());
	    } else {
	      map.put("isSuccess", "N");
	      map.put("errorMessage", datas.getErrorMessage());
	      map.put("errorFile", datas.getErrorFile());
	    } 
	    return map;
	}

}
