package nc.impl.hr.train;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.bs.uap.lock.PKLock;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.vo.hi.cloud.train.CloudFinshDetailVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;

/**
 * £ѵγNCC̨
 * @author chenzf
 * @date 2022-4-20 20:30:06
 * 
 */
public class CloudFinshDetailPlugin implements IBackgroundWorkPlugin {

	@Override
	public PreAlertObject executeTask(BgWorkingContext arg0) throws BusinessException {
		PreAlertObject alertObj = new PreAlertObject();
		if(!PKLock.getInstance().addDynamicLock("CloudFinshDetailPlugin")) {
			alertObj.setReturnObj("ִУظִУ");
			return alertObj;
	    }
		TrainCloudSchoolImpl impl = new TrainCloudSchoolImpl();
		Map<String,Object> bodyMap = impl.getBodyMap();
		Map map = arg0.getKeyMap();
		String updateDate = "";//"yyyy-MM-dd"
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Date today = new Date();//ȡ
		Calendar c = Calendar.getInstance();
		c.setTime(today);
		if(map.get("nums") != null && !"".equals(map.get("nums"))) {
			int nums = Integer.valueOf(arg0.getKeyMap().get("nums").toString());
			if(nums == 0) {
				updateDate = "1997-01-01";
			} else {
				c.add(Calendar.DAY_OF_MONTH, nums);
				updateDate = sdf.format(c.getTime());
			}
		} else {
			c.add(Calendar.DAY_OF_MONTH, 1);
			updateDate = sdf.format(c.getTime());
		}
		BaseDAO dao = new BaseDAO();
		int totalPages = 0;
		//ѵid 
		String trainContentID = "";
		String result = impl.getcontentfinshdetaillist(bodyMap, 1, 500, trainContentID);
		if(StringUtils.isNotBlank(result)) {
			JSONObject jsonObject = JSONObject.parseObject(result);
			String code = jsonObject.getString("code");
			String sql = "select id from cloud_finsh_detail where nvl(dr,0) = 0";
			List<String> list = (List<String>) dao.executeQuery(sql, new ColumnListProcessor());
			List<CloudFinshDetailVO> insertList = new ArrayList();
			if("0".equals(code)) {
				JSONObject paging = jsonObject.getJSONObject("paging");
				if(paging != null) {
					totalPages = paging.getInteger("totalPages");//ҳ
					int totalCount = paging.getInteger("totalCount");//
//					if(totalPages > 1) {
//						count = Integer.valueOf(totalCount) / 500;
//					}
				}
				JSONArray jsonArray = jsonObject.getJSONArray("data");//data
				if(jsonArray != null) {
					List<CloudFinshDetailVO> finshList = JSONArray.parseArray(jsonArray.toJSONString(), CloudFinshDetailVO.class);
					if(finshList != null) {
//						for(int i = 0;i < jsonArray.size(); i++) {
//							JSONObject obj = jsonArray.getJSONObject(i);
//							for(CloudFinshDetailVO finsh : finshList) {
//								if(finsh.getId() != null && finsh.getId().equals(obj.get("id"))) {
//									finsh.setFinshStatus(obj.getString("status"));
//								}
//							}
//						}
						for(CloudFinshDetailVO finsh : finshList) {
							if(!list.contains(finsh.getId())) {
								insertList.add(finsh);
							}
						}
					}
				}
			}
			if(totalPages > 1) {
				for(int i = 2; i < totalPages;i++) {
					result = impl.getcontentfinshdetaillist(bodyMap, i, 500, trainContentID);
					JSONObject ijsonObject = JSONObject.parseObject(result);
					String icode = jsonObject.getString("code");
					if("0".equals(icode)) {
						JSONArray jsonArray = ijsonObject.getJSONArray("data");//data
						if(jsonArray != null) {
							List<CloudFinshDetailVO> finshList = JSONArray.parseArray(jsonArray.toJSONString(), CloudFinshDetailVO.class);
							if(finshList != null) {
//								for(int j = 0;j < jsonArray.size(); j++) {
//									JSONObject obj = jsonArray.getJSONObject(j);
//									for(CloudFinshDetailVO finsh : finshList) {
//										if(finsh.getId() != null && finsh.getId().equals(obj.get("id"))) {
//											finsh.setFinshStatus(obj.getString("status"));
//										}
//									}
//								}
								for(CloudFinshDetailVO finsh : finshList) {
									if(!list.contains(finsh.getId())) {
										insertList.add(finsh);
									}
								}
							}
						}
					}
				}
			}
			
			//жǷѴм
			if(insertList.size() > 0) {
				String[] pks = dao.insertVOList(insertList);
				alertObj.setReturnObj(pks);
				alertObj.setMsgTitle("棨£ѵγ"+pks.length+"");
			}
		}
		return alertObj;
	}

}
