package nc.impl.hr.train;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.bs.uap.lock.PKLock;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.vo.hi.cloud.train.CloudPlanDetailVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pubapp.AppContext;
/**
 * ѧϰƻִϸݵNCC̨
 * @author chenzf
 * @date 2022-4-19 15:53:04
 *
 */
public class CloudPlanDetailPlugin implements IBackgroundWorkPlugin {

	@Override
	public PreAlertObject executeTask(BgWorkingContext arg0) throws BusinessException {
		PreAlertObject alertObj = new PreAlertObject();
		if(!PKLock.getInstance().addDynamicLock("CloudPlanDetailPlugin")) {
			alertObj.setReturnObj("ִУظִУ");
			return alertObj;
	    }
		TrainCloudSchoolImpl impl = new TrainCloudSchoolImpl();
		Map<String,Object> bodyMap = impl.getBodyMap();
		Map map = arg0.getKeyMap();
		String updateDate = "";//"yyyy-MM-dd"
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Date today = new Date();//ȡ
		Calendar c = Calendar.getInstance();
		c.setTime(today);
		if(map.get("nums") != null && !"".equals(map.get("nums"))) {
			int nums = Integer.valueOf(arg0.getKeyMap().get("nums").toString());
			if(nums == 0) {
				updateDate = "2019-01-01";
			} else {
				c.add(Calendar.DAY_OF_MONTH, nums);
				updateDate = sdf.format(c.getTime());
			}
		} else {
			c.add(Calendar.DAY_OF_MONTH, 1);
			updateDate = sdf.format(c.getTime());
		}
		String result = impl.getStudyplandetailpagelist(bodyMap, 1, 500);
		BaseDAO dao = new BaseDAO();
		int totalPages = 0;
		if(StringUtils.isNotBlank(result)) {

			JSONObject jsonObject = JSONObject.parseObject(result);
			String code = jsonObject.getString("code");
			String sql = "select planID || userId from cloud_plan_detail where nvl(dr,0) = 0";
			List<String> list = (List<String>) dao.executeQuery(sql, new ColumnListProcessor());
			List<CloudPlanDetailVO> insertList = new ArrayList();
			if("0".equals(code)) {
				JSONObject paging = jsonObject.getJSONObject("paging");
				if(paging != null) {
					totalPages = paging.getInteger("totalPages");//ҳ
					int totalCount = paging.getInteger("totalCount");//
//					if(totalPages > 1) {
//						count = Integer.valueOf(totalCount) / 500;
//					}
				}
				JSONArray jsonArray = jsonObject.getJSONArray("data");//data
				if(jsonArray != null) {
					List<CloudPlanDetailVO> planList = JSONArray.parseArray(jsonArray.toJSONString(), CloudPlanDetailVO.class);
					if(planList != null) {
//						for(int i = 0;i < jsonArray.size(); i++) {
//							JSONObject obj = jsonArray.getJSONObject(i);
//							for(CloudPlanDetailVO plan : planList) {
//								if(plan.getPlanID() != null && plan.getPlanID().equals(obj.get("planID"))
//									&& plan.getUserId().equals(obj.get("userId"))	
//										) {
//									plan.setPlanStatus(obj.getString("status"));
//								}
//							}
//						}
						for(CloudPlanDetailVO plan : planList) {
							if(!list.contains(plan.getPlanID()+plan.getUserId())) {
								insertList.add(plan);
							}
						}
					}
				}
			}
			if(totalPages > 1) {
				for(int i = 2; i < totalPages;i++) {
					result = impl.getStudyplandetailpagelist(bodyMap, i, 500);
					JSONObject ijsonObject = JSONObject.parseObject(result);
					String icode = jsonObject.getString("code");
					if("0".equals(icode)) {
						JSONArray jsonArray = ijsonObject.getJSONArray("data");//data
						if(jsonArray != null) {
							List<CloudPlanDetailVO> planList = JSONArray.parseArray(jsonArray.toJSONString(), CloudPlanDetailVO.class);
							if(planList != null) {
//								for(int j = 0;j < jsonArray.size(); j++) {
//									JSONObject obj = jsonArray.getJSONObject(j);
//									for(CloudPlanDetailVO plan : planList) {
//										if(plan.getPlanID() != null && plan.getPlanID().equals(obj.get("planID"))
//											&& plan.getUserId().equals(obj.get("userId"))	
//												) {
//											plan.setPlanStatus(obj.getString("status"));
//										}
//									}
//								}
								for(CloudPlanDetailVO plan : planList) {
									if(!list.contains(plan.getPlanID()+plan.getUserId())) {
										insertList.add(plan);
									}
								}
							}
						}
					}
				}
			}
			
			//жǷѴм
			if(insertList.size() > 0) {
				String[] pks = dao.insertVOList(insertList);
				alertObj.setReturnObj(pks);
				alertObj.setMsgTitle("ѧϰƻִϸ"+pks.length+"");
			}
		
		}
		return alertObj;
	}

}
