package nc.impl.hr.train;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;

import nc.bs.dao.BaseDAO;
import nc.bs.pub.pa.PreAlertObject;
import nc.bs.pub.pa.PreAlertReturnType;
import nc.bs.pub.taskcenter.BgWorkingContext;
import nc.bs.pub.taskcenter.IBackgroundWorkPlugin;
import nc.bs.uap.lock.PKLock;
import nc.jdbc.framework.processor.ColumnListProcessor;
import nc.vo.hi.cloud.train.CloudPsnVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;

/**
 * ͬѧԱбݵNCC̨
 * @author chenzf
 * @date 2022-4-19 15:53:04
 *
 */
public class CloudPsnPlugin implements IBackgroundWorkPlugin {

	@Override
	public PreAlertObject executeTask(BgWorkingContext arg0) throws BusinessException {
		PreAlertObject alertObj = new PreAlertObject();
		if(!PKLock.getInstance().addDynamicLock("CloudPsnPlugin")) {
			alertObj.setReturnObj("ִУظִУ");
			return alertObj;
	    }
		TrainCloudSchoolImpl impl = new TrainCloudSchoolImpl();
		Map<String,Object> bodyMap = impl.getBodyMap();
		Map map = arg0.getKeyMap();
		String updateDate = "";//"yyyy-MM-dd"
		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
		Date today = new Date();//ȡ
		Calendar c = Calendar.getInstance();
		c.setTime(today);
		if(map.get("nums") != null && !"".equals(map.get("nums"))) {
			int nums = Integer.valueOf(arg0.getKeyMap().get("nums").toString());
			if(nums == 0) {
				updateDate = "2019-01-01";
			} else {
				c.add(Calendar.DAY_OF_MONTH, nums);
				updateDate = sdf.format(c.getTime());
			}
		} else {
			c.add(Calendar.DAY_OF_MONTH, 1);
			updateDate = sdf.format(c.getTime());
		}
		bodyMap.put("updateDate", updateDate);
		String result = impl.getUserList(bodyMap);
		if(StringUtils.isNotBlank(result)) {
			BaseDAO dao = new BaseDAO();
			JSONObject jsonObject = JSONObject.parseObject(result);
			String code = jsonObject.getString("code");
			if("0".equals(code)) {
				JSONArray jsonArray = jsonObject.getJSONArray("data");//data
				if(jsonArray != null && jsonArray.size() > 0) {
					List<CloudPsnVO> psnVOs = JSONArray.parseArray(jsonArray.toJSONString().replaceAll("status", "cloudStatus"), CloudPsnVO.class);
					if(psnVOs != null) {
						String sql = "select id,pk_cloud from cloud_psndoc where nvl(dr,0) = 0";
						List<Map<String,String>> listMap = (List<Map<String,String>>) dao.executeQuery(sql, new ColumnListProcessor());
						List<String> list = new ArrayList();//idlist
						Map<String,String> idMap = new HashMap();//idΪkeypk_kngcatalogsΪvalue
						if(list != null && list.size() >0) {
							for(Map<String,String> m : listMap) {
								list.add(m.get("id"));
								idMap.put(m.get("id"), m.get("pk_cloud"));
							}
						}
						List<CloudPsnVO> insertList = new ArrayList();
						List<CloudPsnVO> updList = new ArrayList();
						//жǷѴм
						for(CloudPsnVO psnVO : psnVOs) {
							if(!list.contains(psnVO.getId())) {
								insertList.add(psnVO);
							} else {
								psnVO.setPk_cloud(idMap.get("id"));
								updList.add(psnVO);
							}
						}
						alertObj.setMsgTitle("");
						if(insertList.size() > 0) {
							String[] pks = dao.insertVOList(insertList);
							alertObj.setReturnObj(pks);
							alertObj.setMsgTitle("ԱϢ"+pks.length+"!");
						}
						if(updList.size() > 0) {
							dao.updateVOList(updList);
							alertObj.setMsgTitle(alertObj.getMsgTitle()+"޸ԱϢ"+updList.size()+"!");
						}
					}
				}
			} else {
				throw new BusinessException(jsonObject.getString("message"));
			}
		} else {
			throw new BusinessException("ѯresultΪ");
		}
		alertObj.setReturnType(PreAlertReturnType.RETURNMESSAGE);
		return alertObj;
	}

}
