package nccloud.hrkq.hrkq.monthottimevo.action;

import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import nc.bs.logging.Logger;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.hi.psndoc.PsnJobVO;
import nc.vo.hrkq.monthottime.AggMonthOtTimeVO;
import nc.vo.hrkq.monthottime.MonthOtTimeBVO;
import nc.vo.hrkq.monthottime.MonthOtTimeVO;
import nc.vo.pf.change.PfUtilBaseTools;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nc.vo.uap.pf.PfProcessBatchRetObject;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.core.json.IJson;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.container.SessionContext;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.billcard.BillCardOperator;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.CommonUtil;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.NccBillOperatorParam;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.NccCommitReturnInfo;
import nccloud.itf.hrkq.hrkq.IMonthottimevoMaintain;
import nccloud.pubitf.riart.pflow.CloudPFlowContext;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;
import nccloud.vo.hrkq.hrkq.MonthOtTimeVOConst;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hrkq.common.utils.AttendDataUtil;
import nccloud.web.uapbd.commons.web.ParamUtils;
import nccloud.web.workflow.approve.util.NCCFlowUtils;

public class MonthOtTimeVOCommonSaveAction implements ICommonAction {

	@Override
	public Object doAction(IRequest request) {
		ParamUtils param = new ParamUtils(request);
		Object obj = param.get("formData");
		IJson json = JsonFactory.create();
		MonthOtTimeBVO[] bvos = HRNccTemplateUtils.getVOFromGrid(MonthOtTimeBVO.class, json.toJson(obj));
		String appCode = param.getString("appCode",SessionContext.getInstance().getAppcode());
		String userid = SessionContext.getInstance().getClientInfo().getUserid();
		PsnJobVO psnJob = AttendDataUtil.queryPsnJob(null);
		MonthOtTimeVO vo = new MonthOtTimeVO();
		try {
			BillCardOperator billCardOperator = new BillCardOperator();
			setValue(vo,psnJob,appCode);
			AggMonthOtTimeVO aggVO = new AggMonthOtTimeVO();
			aggVO.setParentVO(vo);
			for(MonthOtTimeBVO bvo : bvos) {
				if(bvo.getAttributeValue("otdate") != null) {
					bvo.setAttributeValue("otdate",new UFDateTime(bvo.getAttributeValue("otdate").toString()).getDate());
				}
				if(bvo.getAttributeValue("overtimebegintime") != null) {
					bvo.setAttributeValue("otdate",new UFDateTime(bvo.getAttributeValue("overtimebegintime").toString()).getDate());
				}
			}
			
			aggVO.setChildrenVO(bvos);
			//У鹦
			doBefore(aggVO);
			
			// 2õݵı涯űsavebaseõ
		    AggMonthOtTimeVO rtnObj = this.callActionScript(aggVO);
		    // ȡǰ
		    NccBillOperatorParam operaParam = this.getRequestParam(request);
		    Object resultVOs = this.commit(new AggMonthOtTimeVO[] {rtnObj}, operaParam.getUserObj());
		    // 3ؽܣģתǰBillCardշ룬ʾʽ
//		    Object billcard = billCardOperator.toCard(rtnObj);
		    // 4ؽǰ
		    return resultVOs;
		}catch (BusinessException ex) {
			Logger.error(ex.getMessage(), ex);
			ExceptionUtils.wrapException(ex);
			return ex.getMessage();
		}
	}
	
	protected NccBillOperatorParam getRequestParam(IRequest request) {
	    // request
	    String str = request.read();
	    IJson json = JsonFactory.create();
	    NccBillOperatorParam operaParam = json.fromJson(str, NccBillOperatorParam.class);
	    return operaParam;
	  }
	
	/**
	   * ύָɴ
	   *
	   * @param commitVOs
	   * @param userobj ָϢ
	   * @return
	   * @throws BusinessException
	   */
	  protected Object commit(AggMonthOtTimeVO[] commitVOs, Object userobj)
	      throws BusinessException {
	    Object result = null;
	    // жǷ
	    boolean hasFlow = NCCFlowUtils.hasApproveflowDef(
	    		MonthOtTimeVOConst.CONST_BILLTYPE_COST, commitVOs[0]);
	    // Уύű
	    if (hasFlow) {
	      result = this.callActionScript(commitVOs, userobj);
	    }
	    // ûУύ
	    else {
	      result = this.callAutoApproveActionScript(commitVOs);
	    }
	    return result;
	  }
	  
	  protected Object callActionScript(AggMonthOtTimeVO[] aggVOs,
		      Object content) throws BusinessException {

		    String actionCode = MonthOtTimeVOConst.CONST_ACTION_SAVE;
		    String billType = MonthOtTimeVOConst.CONST_BILLTYPE_COST;

		    CloudPFlowContext context = new CloudPFlowContext();
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);
		    // ָϢΪգָϢ
		    if (content != null) {
		      Map<Object, Object> contentParam = new HashMap<>();
		      contentParam.put("content", content);
		      context.seteParam(contentParam);
		    }

		    Logger.debug("ʼöű ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");
		    ICloudScriptPFlowService service = CommonUtil.getCPFlowService();
		    Object[] result = service.exeScriptPFlow(context);

		    if ((result == null) || (result.length == 0) || (result[0] == null)) {
		      return null;
		    }

		    // begin ύָɹ
		    if (result[0] instanceof Map) {
		      Map map = (Map) result[0];
		      String type = String.valueOf(map.get(PfUtilBaseTools.PARAM_WORKFLOWTYPE));
		      if (PfUtilBaseTools.PARAM_APPROVEFLOW.equals(type)
		          || PfUtilBaseTools.PARAM_WORKFLOW.equals(type)) {
		        NccCommitReturnInfo returnInfo = new NccCommitReturnInfo();
		        returnInfo.setReturnMsg(map);
		        return returnInfo;
		      }
		    }
		    // end ύָɹ

		    // ύ쳣
		    if (result[0] instanceof PfProcessBatchRetObject) {
		      PfProcessBatchRetObject batchRetObject =
		          (PfProcessBatchRetObject) result[0];
		      String errMsg = batchRetObject.getExceptionMsg();
		      if ((errMsg != null) && !"".equals(errMsg)) {
		        ExceptionUtils.wrapBusinessException(errMsg);
		      }
		      return batchRetObject.getRetObj();
		    }

		    Logger.debug(
		        "öű ActionName[" + actionCode + "] BillType[" + billType + "]");
		    return result;
		  }

		  /**
		   * ύ
		   *
		   * @param aggVO
		   * @return
		   * @throws BusinessException
		   */
		  protected Object callAutoApproveActionScript(AggMonthOtTimeVO[] aggVOs)
		      throws BusinessException {

		    String actionCode = this.getActionCode();
		    String billType = MonthOtTimeVOConst.CONST_BILLTYPE_COST;
		    Map<Object, Object> extParam = new HashMap<Object, Object>();
		    extParam.put("IS_RELOADBILL", true);

		    // ύӿ
		    CloudPFlowContext context = new CloudPFlowContext();
		    context.seteParam(extParam);
		    context.setActionName(actionCode);
		    context.setBillType(billType);
		    context.setBillVos(aggVOs);

		    Logger.debug("ʼöű ActionName[" + actionCode + "] BillType[" + billType
		        + "]...");
		    ICloudScriptPFlowService service = CommonUtil.getCPFlowService();
		    Object[] result = service.exeScriptPFlow_CommitNoFlowBatch(context);

		    if ((result == null) || (result.length == 0) || (result[0] == null)) {
		      return null;
		    }
		    if (result[0] instanceof PfProcessBatchRetObject) {
		      PfProcessBatchRetObject batchRetObject =
		          (PfProcessBatchRetObject) result[0];
		      String errMsg = batchRetObject.getExceptionMsg();
		      // û쳣Ϣִгɹ
		      if ((errMsg != null) && !"".equals(errMsg)) {
		        ExceptionUtils.wrapBusinessException(errMsg);
		      }
		      return batchRetObject.getRetObj();
		    }
		    Logger.debug(
		        "öű ActionName[" + actionCode + "] BillType[" + billType + "]");
		    return result;
		  }

	
	/**
	   * 
	   *
	   * @return
	   */
	  protected String getActionCode() {
	    return MonthOtTimeVOConst.CONST_ACTION_SAVEBASE;
	  }

	  /**
	   * öű
	   *
	   * @param actionCode
	   * @param aggVOs
	   * @return
	   * @throws BusinessException
	   */
	  private AggMonthOtTimeVO callActionScript(AggMonthOtTimeVO... aggVOs)
	      throws BusinessException {

	    String actionCode = this.getActionCode();
	    String billType = CommonUtil.getBillTypeCode();

	    CloudPFlowContext context = new CloudPFlowContext();
	    context.setActionName(actionCode);
	    context.setBillType(billType);
	    context.setBillVos(aggVOs);
	    Logger.debug("ʼöű ActionName[" + actionCode + "] BillType[" + billType
	        + "]...");

	    ICloudScriptPFlowService service =
	        ServiceLocator.find(ICloudScriptPFlowService.class);

	    Object[] result = service.exeScriptPFlow(context);

	    Logger.debug("öű ActionName[" + actionCode + "] BillType[" + billType
	        + "]");

	    String wheresql =
	        "pk_monthottime" + "='"
	            + ((AggMonthOtTimeVO) result[0]).getPrimaryKey() + "'";
	    Collection<AggMonthOtTimeVO> bills =
	        CommonUtil.getMDQueryService().queryBillOfVOByCond(
	            AggMonthOtTimeVO.class, wheresql, true, false);
	    Collection<MonthOtTimeBVO> bbills =
	    		CommonUtil.getMDQueryService().queryBillOfVOByCond(MonthOtTimeBVO.class, wheresql, true,
	                false);
	    AggMonthOtTimeVO[] aggvos = bills.toArray(new AggMonthOtTimeVO[0]);
	    aggvos[0].setChildrenVO(bbills.toArray(new MonthOtTimeBVO[0]));
	    return bills.toArray(new AggMonthOtTimeVO[0])[0];
	  }
	/**
	 * ж޸
	 *
	 * @param vo
	 * @throws BusinessException
	 */
	private void doBefore(AggMonthOtTimeVO vo) throws BusinessException {
		String parentPk = vo.getPrimaryKey();
	    // ǷϢж滹޸ı
	    if ((parentPk != null) && !"".equals(parentPk)) {
	      // õĬֵ
	      CircularlyAccessibleValueObject[] allchildren = vo.getAllChildrenVO();
	      if (allchildren != null) {
	        for (CircularlyAccessibleValueObject obj : allchildren) {
	          obj.setAttributeValue("pk_monthottime", parentPk);
	        }
	      }
	    }
//	    PsnJobVO psnjobVO = AttendDataUtil.queryPsnJob(null);
//	    String pk_psndoc = (String) parent.getAttributeValue(MonthOtTimeVO.PK_PSNDOC);
//	    if(StringUtils.isNotBlank(pk_psndoc)) {
//	    	psnjobVO = AttendDataUtil.queryPsnJob(pk_psndoc);
//	    }
		PsnJobVO psnjobVO = AttendDataUtil.queryPsnJob(null);
		nc.vo.hrkq.monthottime.MonthOtTimeVO parent = vo.getParentVO();
	    parent.setAttributeValue(MonthOtTimeVO.PK_PSNDOC,psnjobVO.getPk_psndoc());
	    parent.setAttributeValue(MonthOtTimeVO.PK_DEPT,psnjobVO.getPk_dept());
	    parent.setAttributeValue(MonthOtTimeVO.PK_ORG,psnjobVO.getPk_org());
	    parent.setAttributeValue(MonthOtTimeVO.APPLYDATE,new UFDate());
	    parent.setAttributeValue(MonthOtTimeVO.BILLTYPE,MonthOtTimeVOConst.CONST_BILLTYPE_COST);
	    parent.setAttributeValue(MonthOtTimeVO.APPROVESTATUS, -1);
////	    String org =
////	        (String) parent.getAttributeValue(MonthOtTimeVOConst.FIELD_PK_ORG);
	    String group = CommonUtil.getGroupByOrg(psnjobVO.getPk_org());
	    if ((group != null) && !"".equals(group)) {
	      parent.setAttributeValue(MonthOtTimeVOConst.FIELD_PK_GROUP, group);
	    }
		String pk_psndoc = (String) parent.getAttributeValue(MonthOtTimeVO.PK_PSNDOC);
	    MonthOtTimeBVO[] bvos = (MonthOtTimeBVO[]) vo.getChildrenVO();
	    if(bvos != null && bvos.length > 0) {
	    	//Ӱ,1Ϊottimestype2Ϊͨotdatetype
	    	String otapplytype = (String) parent.getAttributeValue(MonthOtTimeVO.OTAPPLYTYPE);
	    	IMonthottimevoMaintain service = ServiceLocator.find(IMonthottimevoMaintain.class);
	    	List<Map<String, UFDate>> listMap = service.queryHoliday(pk_psndoc, psnjobVO.getPk_org());
	    	List<String> defdocList = service.queryDefdoc();//ѯڼ
	    	String msg = "";
	    	String msg2 = "";
	    	Map<String,String> typeMap = new HashMap();
	    	List<DefdocVO> defVOList = service.queryDefdoc2();
	    	if(defVOList != null && defVOList.size() > 0) {
	    		for(DefdocVO defvo : defVOList) {
	    			typeMap.put(defvo.getPk_defdoc(), defvo.getName());
	    		}
	    	}
	    	for(MonthOtTimeBVO bvo : bvos) {
	    		String type = "";
	    		StringBuffer note = new StringBuffer("");
	    		if("1".equals(otapplytype)) {//
	    			type = (String) bvo.getAttributeValue(MonthOtTimeBVO.OTTIMESTYPE);
//	    			ӰͰ	
//	    			Ӱ	ڸʽYYYY-MM-DD
//	    			Ӱ	ֵһλС
//	    			Ӱ˵	
	    			note.append("<br>ӰͰ:").append(typeMap.get(bvo.getAttributeValue(MonthOtTimeBVO.OTTIMESTYPE))+"");
	    			note.append("<br>Ӱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDATE).toString().substring(0, 10) +"");
	    			note.append("<br>Ӱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTTIMES) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.OTTIMES).toString(),1)+"");
	    			note.append("<br>Ӱ˵:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION).toString() +"");
	    		}else if("2".equals(otapplytype)) {//ͨ
	    			type = (String) bvo.getAttributeValue(MonthOtTimeBVO.OTDATETYPE);
//	    			Ӱ	
//	    			Ӱ	ڸʽYYYY-MM-DD
//	    			ʼʱ	ڸʽYYYY-MM-DD HH:MM:SS
//	    			ʱ	ڸʽYYYY-MM-DD HH:MM:SS
//	    			ӰʱСʱ	ֵһλС
//	    			Ӱʱ	ֵһλС
//	    			ʱ	ֵһλС
//	    			Ӱ˵	
	    			note.append("<br>Ӱ:").append(typeMap.get(bvo.getAttributeValue(MonthOtTimeBVO.OTDATETYPE))+"\n");
	    			note.append("<br>Ӱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDATE).toString().substring(0, 10) +"");
	    			note.append("<br>ʼʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME).toString() +"");
	    			note.append("<br>ʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME).toString() +"");
	    			note.append("<br>ӰʱСʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTHOURS) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.OTHOURS).toString(),1)+"");
	    			note.append("<br>Ӱʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTCOSTHOURS) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.OTCOSTHOURS).toString(),1)+"");
	    			note.append("<br>ʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.LEAVEHOURS) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.LEAVEHOURS).toString(),1)+"");
	    			note.append("<br>Ӱ˵:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION).toString() +"");
	    		}
	    		
	    		bvo.setAttributeValue("note", note.toString());
	    		
	    		if(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE) == null) {
	    			continue;
	    		}
	    		UFDate otdate = new UFDate(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE).toString());//ӰǷΪڼ
	    		if(this.checkDate(otdate, listMap)) {
	    			if(type.length() > 0 && !defdocList.contains(type)) {
	    				msg = "["+otdate.toString().substring(0,10)+"],";
	    			}
	    		} else {
	    			if(type.length() > 0 && defdocList.contains(type)) {
	    				msg2 = "["+otdate.toString().substring(0,10)+"],";
	    			}
	    		}
	    	}
	    	if(msg.length() > 0 && msg2.length() > 0) {
	    		throw new BusinessException("Ӱ"+msg+"ڽڼռӰ,Ӱ"+msg2+"ڽڼռӰ࣬ѡȷļӰ");
	    	}else if(msg.length() > 0) {
	    		throw new BusinessException("Ӱ"+msg+"ڽڼռӰ࣬ѡȷļӰ");
	    	}else if(msg2.length() > 0) {
	    		throw new BusinessException("Ӱ"+msg2+"ڽڼռӰ࣬ѡȷļӰ");
	    	}
	    }
	    
	    String dateCheckMsg = CommonUtil.checkSelf(bvos);
	    if(dateCheckMsg != null) {
	    	throw new BusinessException("Ӱʱ䷶ΧڴڳͻļӰ൥");
	    }
	    
	    List<MonthOtTimeBVO> oldBvos = CommonUtil.getMaintainService().queryBVOByPkPsndoc(pk_psndoc);
	    if(oldBvos != null && oldBvos.size() > 0) {
		    String dateTwoCheckMsg = CommonUtil.checkTwoList(bvos,oldBvos.toArray(new MonthOtTimeBVO[0]));
		    if(dateTwoCheckMsg != null) {
		    	throw new BusinessException("Ӱʱ䷶ΧڴڳͻļӰ൥");
		    }
	    }
	}
	
    /**
     * жǷϽڼʱ
     * @param otdate
     * @param listMap
     * @return
     */
    private Boolean checkDate(UFDate otdate,List<Map<String, UFDate>> listMap) {
  	  Boolean check = Boolean.FALSE;
  	  if(listMap != null) {
  			for(Map<String, UFDate> map : listMap) {
  				UFDate begindate = map.get("begintime");
  				UFDate enddate = map.get("endtime");
  				if(otdate.compareTo(begindate) >= 0 && otdate.compareTo(enddate) <= 0) {
  					check = Boolean.TRUE;
  					break;
  				}
  			}
  		}
  	  
  	  return check;
    }
	
	public void setValue(MonthOtTimeVO vo,PsnJobVO psnJob,String appCode) throws BusinessException{
		if("606570D0".equals(appCode)) {
			//
			vo.setOtapplytype("1");
			vo.setAttributeValue("otapplytype", "1");
		}else if("606570C0".equals(appCode) || "606570E0".equals(appCode)) {
			//ͨ
			vo.setOtapplytype("2");
			vo.setAttributeValue("otapplytype", "2");
		}
	}

}
