
package nccloud.hrkq.hrkq.monthottimevo.action;

import java.util.Collection;

import nc.bs.logging.Logger;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nccloud.vo.hrkq.hrkq.MonthOtTimeVOConst;
import nc.vo.hrkq.monthottime.AggMonthOtTimeVO;
import nc.vo.hrkq.monthottime.MonthOtTimeVO;
import nc.vo.pf.pub.util.SQLUtil;
import nc.vo.pub.BusinessException;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.bean.PageQueryInfo;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.CommonUtil;
import nccloud.pubitf.riart.pflow.CloudPFlowContext;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;

/**
 * ɾ֧
 * @version  @since v3.5.6-1903
 */
public class MonthOtTimeVODeleteAction implements ICommonAction {

  @Override
  public Object doAction(IRequest paramIRequest) {
    PageQueryInfo queryParam = this.getQueryParam(paramIRequest);
    try {
      // 1ǰ˴ݵpksѯ,ȡAGGVO
      AggMonthOtTimeVO[] bills = this.queryBills(queryParam);
      // 2õݵı涯űdeleteõ
      this.callActionScript(bills);
      // 3Null ǰ
      return null;
    }
    catch (BusinessException ex) {
      // 쳣Ϣ
      Logger.error(ex);
      ExceptionUtils.wrapException(ex);
    }
    return null;
  }

  /**
   * 
   *
   * @return
   */
  protected String getActionCode() {
    return MonthOtTimeVOConst.CONST_ACTION_DELETE;
  }

  /**
   * öű
   *
   * @param actionCode
   * @param aggVOs
   * @return
   * @throws BusinessException
   */
  private Object callActionScript(AggMonthOtTimeVO... aggVOs)
      throws BusinessException {

    if ((aggVOs == null) || (aggVOs.length == 0)) {
      return null;
    }

    String actionCode = this.getActionCode();
    String billType = CommonUtil.getBillTypeCode();

    CloudPFlowContext context = new CloudPFlowContext();
    context.setActionName(actionCode);
    context.setBillType(billType);
    context.setBillVos(aggVOs);
    Logger.debug("ʼöű ActionName[" + actionCode + "] BillType[" + billType
        + "]...");

    ICloudScriptPFlowService service =
        ServiceLocator.find(ICloudScriptPFlowService.class);

    Object[] result = service.exeScriptPFlow(context);

    Logger.debug("öű ActionName[" + actionCode + "] BillType[" + billType
        + "]");

    return result;
  }

  /**
   * ȡѯ
   *
   * @param paramIRequest
   * @return
   */
  private PageQueryInfo getQueryParam(IRequest paramIRequest) {
    String strRead = paramIRequest.read();
    PageQueryInfo queryParam =
        JsonFactory.create().fromJson(strRead, PageQueryInfo.class);
    return queryParam;
  }

  /**
   * ѯҵ
   *
   * @param queryParam
   * @return
   * @throws MetaDataException
   */
  private AggMonthOtTimeVO[] queryBills(PageQueryInfo queryParam)
      throws MetaDataException {
    // 1ݲѯ
    IMDPersistenceQueryService service = CommonUtil.getMDQueryService();
    String wheresql =
        SQLUtil.buildSqlForIn( "pk_monthottime",
            queryParam.getPks());
    Collection<AggMonthOtTimeVO> bills =
        service.queryBillOfVOByCond(AggMonthOtTimeVO.class, wheresql, true,
            false);
    if ((bills == null) || (bills.size() == 0)) {
      return null;
    }
    return bills.toArray(new AggMonthOtTimeVO[0]);
  }
}
