
package nccloud.hrkq.hrkq.monthottimevo.action;
import java.math.BigDecimal;
import java.util.Collection;

import nc.bs.logging.Logger;
import nc.md.model.MetaDataException;
import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.vo.hrkq.monthottime.AggMonthOtTimeVO;
import nc.vo.hrkq.monthottime.MonthOtTimeBVO;
import nc.vo.pub.BusinessException;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.framework.web.ui.pattern.billcard.BillCard;
import nccloud.framework.web.ui.pattern.billcard.BillCardOperator;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.bean.PageQueryInfo;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.CommonUtil;

/**
 * Ƭѯѯ
 * @version  @since v3.5.6-1903
 */
public class MonthOtTimeVOQueryCardAction implements ICommonAction {

  @Override
  public Object doAction(IRequest paramIRequest) {
    PageQueryInfo queryParam = this.getQueryParam(paramIRequest);
    try {
      // ѯ
      Collection<AggMonthOtTimeVO> bills = this.queryBills(queryParam);
      if (bills == null) {
        return null;
      }
      // תǰҪbillCard
      return this.transBillCardFormVO(queryParam,
          bills.toArray(new AggMonthOtTimeVO[0])[0]);
    }
    catch (BusinessException ex) {
      // 쳣Ϣ
      Logger.error(ex);
      ExceptionUtils.wrapException(ex);
    }
    return null;
  }

  /**
   * ȡѯ
   *
   * @param paramIRequest
   * @return
   */
  private PageQueryInfo getQueryParam(IRequest paramIRequest) {
    String strRead = paramIRequest.read();
    PageQueryInfo queryParam =
        JsonFactory.create().fromJson(strRead, PageQueryInfo.class);
    return queryParam;
  }

  /**
   * ѯҵ
   *
   * @param queryParam
   * @return
   * @throws MetaDataException
   */
  private Collection<AggMonthOtTimeVO> queryBills(PageQueryInfo queryParam)
      throws MetaDataException {
    IMDPersistenceQueryService service = CommonUtil.getMDQueryService();
    // ע⣺ҵṩѯԪݲѯĬϲѯdr=1ˣ
    String wheresql =
        "pk_monthottime" + "='" + queryParam.getPk() + "'";
    Collection<AggMonthOtTimeVO> bills =
        service.queryBillOfVOByCond(AggMonthOtTimeVO.class, wheresql, true,
            false);
    
    Collection<MonthOtTimeBVO> bbills =
            service.queryBillOfVOByCond(MonthOtTimeBVO.class, wheresql, true,
                false);
    AggMonthOtTimeVO[] aggvos = bills.toArray(new AggMonthOtTimeVO[0]);
    aggvos[0].setChildrenVO(bbills.toArray(new MonthOtTimeBVO[0]));
    return bills;
  }

  /**
   * VO ת
   *
   * @param queryParam
   * @param bill
   * @return
   */
  private BillCard transBillCardFormVO(PageQueryInfo queryParam,
      AggMonthOtTimeVO bill) {
    BillCardOperator operator = new BillCardOperator(queryParam.getPagecode());
    return operator.toCard(bill);
  }
}
