
package nccloud.hrkq.hrkq.monthottimevo.action;

import java.text.SimpleDateFormat;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

import nc.bs.logging.Logger;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.hi.psndoc.PsnJobVO;
import nc.vo.hrkq.monthottime.AggMonthOtTimeVO;
import nc.vo.hrkq.monthottime.MonthOtTimeBVO;
import nc.vo.hrkq.monthottime.MonthOtTimeVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.VOStatus;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nc.vo.pub.lang.UFDouble;
import nccloud.framework.core.exception.ExceptionUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.action.itf.ICommonAction;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.ui.pattern.billcard.BillCardOperator;
import nccloud.hrkq.hrkq.monthottimevo.hrkq.util.CommonUtil;
import nccloud.itf.hrkq.hrkq.IMonthottimevoMaintain;
import nccloud.pubitf.riart.pflow.CloudPFlowContext;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;
import nccloud.vo.hrkq.hrkq.MonthOtTimeVOConst;
import nccloud.web.hrkq.common.utils.AttendDataUtil;

/**
 * ӱ
 * @version  @since v3.5.6-1903
 */
public class MonthOtTimeVOSaveAction implements ICommonAction {

  @Override
  public Object doAction(IRequest paramIRequest) {
    try {
      BillCardOperator billCardOperator = new BillCardOperator();
      // 1ȡAGGVO requestתVO
      AggMonthOtTimeVO vo = billCardOperator.toBill(paramIRequest);
      this.doBefore(vo);
      // 2õݵı涯űsavebaseõ
      AggMonthOtTimeVO rtnObj = this.callActionScript(vo);
      // 3ؽܣģתǰBillCardշ룬ʾʽ
      Object billcard = billCardOperator.toCard(rtnObj);
      // 4ؽǰ
      return billcard;
    }
    catch (BusinessException ex) {
      // 쳣Ϣ
      Logger.error(ex);
      ExceptionUtils.wrapException(ex);
    }
    return null;
  }

  /**
   * 
   *
   * @return
   */
  protected String getActionCode() {
    return MonthOtTimeVOConst.CONST_ACTION_SAVEBASE;
  }

  /**
   * öű
   *
   * @param actionCode
   * @param aggVOs
   * @return
   * @throws BusinessException
   */
  private AggMonthOtTimeVO callActionScript(AggMonthOtTimeVO... aggVOs)
      throws BusinessException {

    String actionCode = this.getActionCode();
    String billType = CommonUtil.getBillTypeCode();

    CloudPFlowContext context = new CloudPFlowContext();
    context.setActionName(actionCode);
    context.setBillType(billType);
    context.setBillVos(aggVOs);
    Logger.debug("ʼöű ActionName[" + actionCode + "] BillType[" + billType
        + "]...");

    ICloudScriptPFlowService service =
        ServiceLocator.find(ICloudScriptPFlowService.class);

    Object[] result = service.exeScriptPFlow(context);

    Logger.debug("öű ActionName[" + actionCode + "] BillType[" + billType
        + "]");

    String wheresql =
        "pk_monthottime" + "='"
            + ((AggMonthOtTimeVO) result[0]).getPrimaryKey() + "'";
    Collection<AggMonthOtTimeVO> bills =
        CommonUtil.getMDQueryService().queryBillOfVOByCond(
            AggMonthOtTimeVO.class, wheresql, true, false);
    Collection<MonthOtTimeBVO> bbills =
    		CommonUtil.getMDQueryService().queryBillOfVOByCond(MonthOtTimeBVO.class, wheresql, true,
                false);
    AggMonthOtTimeVO[] aggvos = bills.toArray(new AggMonthOtTimeVO[0]);
    aggvos[0].setChildrenVO(bbills.toArray(new MonthOtTimeBVO[0]));
    return bills.toArray(new AggMonthOtTimeVO[0])[0];
  }

    /**
    * ж޸
    *
    * @param vo
    * @throws BusinessException
    */
  private void doBefore(AggMonthOtTimeVO vo) throws BusinessException {
    String parentPk = vo.getPrimaryKey();
    // ǷϢж滹޸ı
    if ((parentPk != null) && !"".equals(parentPk)) {
      // õĬֵ
      CircularlyAccessibleValueObject[] allchildren = vo.getAllChildrenVO();
      if (allchildren != null) {
        for (CircularlyAccessibleValueObject obj : allchildren) {
          obj.setAttributeValue("pk_monthottime", parentPk);
          if(StringUtils.isNotBlank(obj.getPrimaryKey()) && VOStatus.UNCHANGED == obj.getStatus()) {
        	  obj.setStatus(VOStatus.UPDATED);
          }
        }
      }
    }
    nc.vo.hrkq.monthottime.MonthOtTimeVO parent = vo.getParentVO();
    PsnJobVO psnjobVO = AttendDataUtil.queryPsnJob(null);
    String pk_psndoc = (String) parent.getAttributeValue(MonthOtTimeVO.PK_PSNDOC);
    if(StringUtils.isNotBlank(pk_psndoc)) {
    	psnjobVO = AttendDataUtil.queryPsnJob(pk_psndoc);
    	pk_psndoc = psnjobVO.getPk_psndoc();
    }
    parent.setAttributeValue(MonthOtTimeVO.PK_PSNDOC,psnjobVO.getPk_psndoc());
    parent.setAttributeValue(MonthOtTimeVO.PK_DEPT,psnjobVO.getPk_dept());
    parent.setAttributeValue(MonthOtTimeVO.PK_ORG,psnjobVO.getPk_org());
    parent.setAttributeValue(MonthOtTimeVO.APPLYDATE,new UFDate());
    parent.setAttributeValue(MonthOtTimeVO.BILLTYPE,MonthOtTimeVOConst.CONST_BILLTYPE_COST);
    parent.setAttributeValue(MonthOtTimeVO.APPROVESTATUS, -1);
//    String org =
//        (String) parent.getAttributeValue(MonthOtTimeVOConst.FIELD_PK_ORG);
    String group = CommonUtil.getGroupByOrg(psnjobVO.getPk_org());
    if ((group != null) && !"".equals(group)) {
      parent.setAttributeValue(MonthOtTimeVOConst.FIELD_PK_GROUP, group);
    }
    
    MonthOtTimeBVO[] bvos = (MonthOtTimeBVO[]) vo.getChildrenVO();
    if(bvos != null && bvos.length > 0) {
    	//Ӱ,1Ϊottimestype2Ϊͨotdatetype
    	String otapplytype = (String) parent.getAttributeValue(MonthOtTimeVO.OTAPPLYTYPE);
    	IMonthottimevoMaintain service = ServiceLocator.find(IMonthottimevoMaintain.class);
    	List<Map<String, UFDate>> listMap = service.queryHoliday(pk_psndoc, psnjobVO.getPk_org());
    	List<String> defdocList = service.queryDefdoc();//ѯڼ
    	String msg = "";
    	String msg2 = "";
    	Map<String,String> typeMap = new HashMap();
    	List<DefdocVO> defVOList = service.queryDefdoc2();
    	if(defVOList != null && defVOList.size() > 0) {
    		for(DefdocVO defvo : defVOList) {
    			typeMap.put(defvo.getPk_defdoc(), defvo.getName());
    		}
    	}
    	for(MonthOtTimeBVO bvo : bvos) {
    		String type = "";
    		StringBuffer note = new StringBuffer("");
    		if("1".equals(otapplytype)) {//
    			type = (String) bvo.getAttributeValue(MonthOtTimeBVO.OTTIMESTYPE);
    			note.append("<br>ӰͰ:").append(typeMap.get(bvo.getAttributeValue(MonthOtTimeBVO.OTTIMESTYPE))+"");
    			note.append("<br>Ӱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDATE).toString().substring(0, 10) +"");
    			note.append("<br>ʼʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME).toString() +"");
    			note.append("<br>ʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME).toString() +"");
    			note.append("<br>Ӱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTTIMES) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.OTTIMES).toString(),1)+"");
    			note.append("<br>Ӱ˵:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION).toString() +"");
    			if(StringUtils.isBlank(type)) {
    				throw new BusinessException("ӰͰֶβΪ");
    			}
    		}else if("2".equals(otapplytype)) {//ͨ
    			type = (String) bvo.getAttributeValue(MonthOtTimeBVO.OTDATETYPE);
    			note.append("<br>Ӱ:").append(typeMap.get(bvo.getAttributeValue(MonthOtTimeBVO.OTDATETYPE))+"");
    			note.append("<br>Ӱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDATE).toString().substring(0, 10) +"");
    			note.append("<br>ʼʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME).toString() +"");
    			note.append("<br>ʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME).toString() +"");
    			note.append("<br>ӰʱСʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTHOURS) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.OTHOURS).toString(),1)+"");
    			note.append("<br>Ӱʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTCOSTHOURS) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.OTCOSTHOURS).toString(),1)+"");
    			note.append("<br>ʱ:").append(bvo.getAttributeValue(MonthOtTimeBVO.LEAVEHOURS) == null ? "" :  new UFDouble(bvo.getAttributeValue(MonthOtTimeBVO.LEAVEHOURS).toString(),1)+"");
    			note.append("<br>Ӱ˵:").append(bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION) == null ? "" : bvo.getAttributeValue(MonthOtTimeBVO.OTDESCRIPTION).toString() +"");
    			if(StringUtils.isBlank(type)) {
    				throw new BusinessException("ӰֶβΪ");
    			}
    		}
    		
    		bvo.setAttributeValue("note", note.toString());
    		
    		if(bvo.getAttributeValue(MonthOtTimeBVO.OTDATE) == null) {
    			continue;
    		}
    		UFDate otdate = (UFDate) bvo.getAttributeValue(MonthOtTimeBVO.OTDATE);//ӰǷΪڼ
    		if(this.checkDate(otdate, listMap)) {
    			if(type.length() > 0 && !defdocList.contains(type)) {
    				msg = "["+otdate.toString().substring(0,10)+"],";
    			}
    		} else {
    			if(type.length() > 0 && defdocList.contains(type)) {
    				msg2 = "["+otdate.toString().substring(0,10)+"],";
    			}
    		}
    	}
    	if(msg.length() > 0 && msg2.length() > 0) {
    		throw new BusinessException("Ӱ"+msg+"ڽڼռӰ,Ӱ"+msg2+"ڽڼռӰ࣬ѡȷļӰ");
    	}else if(msg.length() > 0) {
    		throw new BusinessException("Ӱ"+msg+"ڽڼռӰ࣬ѡȷļӰ");
    	}else if(msg2.length() > 0) {
    		throw new BusinessException("Ӱ"+msg2+"ڽڼռӰ࣬ѡȷļӰ");
    	}
    	
    }
    
    String dateCheckMsg = CommonUtil.checkSelf(bvos);
    if(dateCheckMsg != null) {
    	throw new BusinessException("Ӱʱ䷶ΧڴڳͻļӰ൥");
    }
    
    List<MonthOtTimeBVO> oldBvos = CommonUtil.getMaintainService().queryBVOByPkPsndoc(pk_psndoc);
    if(oldBvos != null && oldBvos.size() > 0) {
	    String dateTwoCheckMsg = CommonUtil.checkTwoList(bvos,oldBvos.toArray(new MonthOtTimeBVO[0]));
	    if(dateTwoCheckMsg != null) {
	    	throw new BusinessException("Ӱʱ䷶ΧڴڳͻļӰ൥");
	    }
    }
  }
  
  /**
   * жǷϽڼʱ
   * @param otdate
   * @param listMap
   * @return
   */
  private Boolean checkDate(UFDate otdate,List<Map<String, UFDate>> listMap) {
	  Boolean check = Boolean.FALSE;
	  if(listMap != null) {
			for(Map<String, UFDate> map : listMap) {
				UFDate begindate = map.get("begintime");
				UFDate enddate = map.get("endtime");
				if(otdate.compareTo(begindate) >= 0 && otdate.compareTo(enddate) <= 0) {
					check = Boolean.TRUE;
					break;
				}
			}
		}
	  
	  return check;
  }
  
}
