
package nccloud.hrkq.hrkq.monthottimevo.hrkq.util;


import java.text.SimpleDateFormat;
import java.util.Map;

import nc.md.persist.framework.IMDPersistenceQueryService;
import nc.pubitf.org.cache.IOrgUnitPubService_C;
import nc.vo.hrkq.monthottime.AggMonthOtTimeVO;
import nc.vo.hrkq.monthottime.MonthOtTimeBVO;
import nc.vo.org.OrgVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDateTime;
import nccloud.framework.core.model.entity.AbstractBill;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.SessionContext;
import nccloud.itf.hrkq.hrkq.IMonthottimevoMaintain;
import nccloud.pubitf.riart.pflow.ICloudScriptPFlowService;
import nccloud.vo.hrkq.hrkq.MonthOtTimeVOConst;

public class CommonUtil {

  private static IMonthottimevoMaintain maintain = null;

  private static IMDPersistenceQueryService persistenceQueryService = null;

  private static ICloudScriptPFlowService PFlowService = null;

  /**
   * ͱ
   *
   * @return
   */
  public static String getBillTypeCode() {
    return MonthOtTimeVOConst.CONST_BILLTYPE_COST;
  }


  /**
   * ȡǰҵʱ
   *
   * @return
   */
  public static UFDate getBusiDate() {
    return new UFDate(SessionContext.getInstance().getClientInfo()
        .getBizDateTime());
  }

  /**
   * ȡǰҵʱ
   *
   * @return
   */
  public static UFDateTime getBusiDateTime() {
    return new UFDateTime(SessionContext.getInstance().getClientInfo()
        .getBizDateTime());
  }

  /**
   * ƽ̨ű
   *
   * @return
   */
  public static synchronized ICloudScriptPFlowService getCPFlowService() {
    if (CommonUtil.PFlowService == null) {
      CommonUtil.PFlowService =
          ServiceLocator.find(ICloudScriptPFlowService.class);
    }
    return CommonUtil.PFlowService;
  }

  /**
   * 
   *
   * @return
   */
  public static IMonthottimevoMaintain getMaintainService() {
    if (CommonUtil.maintain == null) {
      CommonUtil.maintain = ServiceLocator.find(IMonthottimevoMaintain.class);
    }
    return CommonUtil.maintain;
  }

  /**
   * Ԫݲѯ
   *
   * @return
   */
  public static IMDPersistenceQueryService getMDQueryService() {
    if (CommonUtil.persistenceQueryService == null) {
      CommonUtil.persistenceQueryService =
          ServiceLocator.find(IMDPersistenceQueryService.class);
    }
    return CommonUtil.persistenceQueryService;
  }


  /**
   * ѯ֯ڼ
   *
   * @param pk_org
   * @return
   * @throws BusinessException
   */
  public static String getGroupByOrg(String pk_org) throws BusinessException {
    IOrgUnitPubService_C orgUnitQryService =
        ServiceLocator.find(IOrgUnitPubService_C.class);
    OrgVO[] orgVOs = orgUnitQryService.getOrgs(new String[] {
      pk_org
    }, new String[] {
      OrgVO.PK_GROUP
    });
    if ((orgVOs == null) || (orgVOs.length <= 0)) {
      return null;
    }
    return (String) orgVOs[0].getAttributeValue(OrgVO.PK_GROUP);
  }

  /**
   * ̨VOֵǰ̨ʱ
   *
   * @param pk_org
   * @return
   */
  public static void setBillsTs(Map<String, String> pkMapTs,
      AggMonthOtTimeVO[] operaVOs) {
    if (pkMapTs == null) {
      return;
    }
    for (AggMonthOtTimeVO bill : operaVOs) {
      String ts = pkMapTs.get(bill.getParent().getPrimaryKey());
      if ((ts == null) || ts.equals("")) {
        break;
      }
      bill.getParent().setAttributeValue("ts", ts);
    }
  }

  /**
   * @Param:
   * @Description: listѯʱͻ,
   * Ż1: list, jܴ0ʼ,ֻҪݱȽϴС
   * @Author: zyf    2019/3/29
   */
  public static String checkSelf(MonthOtTimeBVO[] list) {
      String res = null;
      if (list.length == 0) {
          return res;
      }
      for (int i = 0; i < list.length; i++) {
          UFDateTime I_S = (UFDateTime) list[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME);
          UFDateTime I_E = (UFDateTime) list[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME);
         // for (int j = 0; j < list.size(); j++) {
          for (int j = i+1; j < list.length; j++) {
             /* if (i == j) {
                  continue;  //Ƚ
              }*/
        	  UFDateTime J_S = (UFDateTime) list[j].getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME);
        	  UFDateTime J_E = (UFDateTime) list[j].getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME);
              //ʹcompareTo, ΪgetTime()ʱ䲻̫׼ȷ
              if ((J_S.compareTo(I_S) == -1 && I_S.compareTo(J_E) == -1) || (J_S.compareTo(I_E) == -1 && I_E.compareTo(J_E) == -1) 
            		  || (I_S.compareTo(J_S) == -1 && J_S.compareTo(I_E) == -1)  || (I_S.compareTo(J_E) == -1 && J_E.compareTo(I_E) == -1)
              		  || J_E.compareTo(I_S) == 0 || J_S.compareTo(I_E) == 0 || J_E.compareTo(I_E) == 0 || J_S.compareTo(I_S) == 0) {
                  res =  dateToStr((UFDateTime)list[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME)) + " "
                          + dateToStr((UFDateTime)list[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME));
                  break;
              }
          }
      }
      return res;
  }
  
  /**
   * @Param: listNew ǰ˴list
   * @Param: listOld ݿlist,
   * Ż2*****˲ѯݿԸǰ˵listʱСʱΪѯ
   * @Description: Ƚǰ˴listݿlistʱͻ
   * @Author: zyf    2019/3/29
   */
  public static String checkTwoList(MonthOtTimeBVO[] listNew, MonthOtTimeBVO[] listOld) {
      String res = null;  //ûгͻnull,гͻسͻʱ
      for (int i = 0; i < listNew.length; i++) {
    	  UFDateTime I_S = (UFDateTime)listNew[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME);
    	  UFDateTime I_E = (UFDateTime)listNew[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME);
    	  String jobIdNew = (String) listNew[i].getAttributeValue(MonthOtTimeBVO.PK_MONTHOTTIME_B);
          for (int j = 0; j < listOld.length; j++) {
        	  UFDateTime J_S = listOld[j].getOvertimebegintime();
        	  UFDateTime J_E = listOld[j].getOvertimeendtime();
        	  String jobIdOld = listOld[j].getPk_monthottime_b();

              if (jobIdNew != null && jobIdNew.equals(jobIdOld)) {
                  continue; // ǰ̨Ǿ޸ĲٸԼȽ
              }
              
              if(J_S == null || J_E == null) {
            	  continue;
              }
              
              //compareToؽ-1 0 1 ʾǰ߱Ⱥ<,=,>ϵ ,ifж漰ȽϿŻ
              if ((J_S.compareTo(I_S) == -1 && I_S.compareTo(J_E) == -1)
                      || (J_S.compareTo(I_E) == -1 && I_E.compareTo(J_E) == -1) || (I_S.compareTo(J_S) == -1 && J_S.compareTo(I_E) == -1)
                      || (I_S.compareTo(J_E) == -1 && J_E.compareTo(I_E) == -1) || J_E.compareTo(I_S) == 0 || J_S.compareTo(I_E) == 0
                      || J_E.compareTo(I_E) == 0 || J_S.compareTo(I_S) == 0) {
                  res = dateToStr((UFDateTime)listNew[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEBEGINTIME)) + " "
                          + dateToStr((UFDateTime)listNew[i].getAttributeValue(MonthOtTimeBVO.OVERTIMEENDTIME));
                  break;
              }
          }
      }
      return res;
  }
  
  public static final String DATE_FORMAT_Y_M_DHM = "yyyy-MM-dd HH:mm:ss";
  public static String dateToStr(UFDateTime date) {
      String strDate = "";
      SimpleDateFormat sdf = new SimpleDateFormat(DATE_FORMAT_Y_M_DHM);
      strDate = sdf.format(date.getDate().toDate());
      return strDate;
  }
}
