package nccloud.web.hryf.transapply.action;

import java.util.HashMap;
import java.util.Map;

import nccloud.commons.lang.StringUtils;

import nc.bs.framework.common.NCLocator;
import nc.bs.uif2.validation.ValidationFailure;
import nc.hr.utils.ResHelper;
import nc.itf.hi.seqcontrol.ISeqcontrolManageService;
import nc.itf.hr.frame.IPersistenceRetrieve;
import nc.itf.trn.IItemSetAdapter;
import nc.vo.hi.psndoc.CtrtVO;
import nc.vo.hi.seqcontrol.SeqcontrolSetVO;
import nc.vo.hi.trnstype.TrnstypeFlowVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.SuperVO;
import nc.vo.pub.billtype.BilltypeVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.pf.IPfRetCheckInfo;
import nc.vo.trn.partmng.PartApplyVO;
import nc.vo.trn.pub.TRNConst;
import nc.vo.trn.transmng.StapplyVO;
import nc.vo.uif2.LoginContext;
import nccloud.dto.hryf.tools.HRYFConst;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.ui.meta.FormItemMeta;
import nccloud.framework.web.ui.meta.FormMeta;
import nccloud.framework.web.ui.meta.PageMeta;
import nccloud.web.hr.pub.HRNccPubEnv;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * -ť
 * @author lbt 20190330
 *
 */
public class TransAddAction extends TransBaseAction {

	@Override
	public <T> Object execute(IRequest request, T para) throws Exception {
		ParamUtils param = new ParamUtils(request);
		LoginContext context = HRNccUtils.getLoginContext(param);
		// 1УݲĿ
		IItemSetAdapter[] items = super.transtypeNotNullValidate(param, context);
		AggregatedValueObject  aggvo = super.getDefaultValue(context, param,false);
		//䷽ʽ
		Integer transMode = param.getInt("transMode", null);
		if(transMode==null){
			return new ValidationFailure(ResHelper.getString("6009tran", "06009tran0129")/* @res "ǰѡĵ䷽ʽΪգܽк" */);
		}
		((StapplyVO)aggvo.getParentVO()).setStapply_mode(transMode);
		((StapplyVO) aggvo.getParentVO()).setWorkflow_state(IPfRetCheckInfo.NOSTATE);
		String transType = param.getString("transType", null);//ҵ
		((StapplyVO)aggvo.getParentVO()).setPk_trnstype(transType);
		TrnstypeFlowVO[] flow =  (TrnstypeFlowVO[]) ServiceLocator.find(IPersistenceRetrieve.class).retrieveByClause(null, TrnstypeFlowVO.class,
                        " pk_group = '" + HRNccPubEnv.getPk_group() + "' and pk_trnstype = '" + transType + "'");
		if (flow != null && flow.length > 0) {
			 ((StapplyVO) aggvo.getParentVO()).setTranstypeid(flow[0].getPk_transtype());
			 ((StapplyVO) aggvo.getParentVO()).setTranstype(null);
             if (StringUtils.isNotEmpty(flow[0].getPk_transtype())){
                 BilltypeVO billtype = (BilltypeVO) ServiceLocator.find(IPersistenceRetrieve.class) .retrieveByPk(null, BilltypeVO.class, flow[0].getPk_transtype());
                 ((StapplyVO) aggvo.getParentVO()).setTranstype(billtype.getPk_billtypecode());
             }
             ((StapplyVO) aggvo.getParentVO()).setBusiness_type(flow[0].getPk_businesstype());
        }
		
		//ǰĿģ
		PageMeta pm = showAllSetItems(context, HRYFConst.APPCODE_TRANAPPLY, HRYFConst.PAGECODE_TRANAPPLY, true, items, false);
        ((FormMeta) pm.getAreaMeta(TRNConst.TRNS_NEWINFO_TAB)).getItemByCode(StapplyVO.NEWPK_POSTSERIES).setDisabled(false);
        ((FormMeta) pm.getAreaMeta(TRNConst.TRNS_NEWINFO_TAB)).getItemByCode(StapplyVO.NEWPK_JOBGRADE).setDisabled(true);// ʱְɱ༭
		// ԱϢ
		FormMeta fm_psninfo = (FormMeta) pm.getAreaMeta(TRNConst.TRNS_PSNINFO_TAB);
		fm_psninfo.getItemByCode(StapplyVO.PK_PSNJOB).setDisabled(false);
		fm_psninfo.getItemByCode(StapplyVO.PK_PSNJOB).setRequired(true);
		fm_psninfo.getItemByCode(StapplyVO.STAPPLY_MODE).setDisabled(true);		
		fm_psninfo.getItemByCode(StapplyVO.STAPPLY_MODE).setRequired(false);	
		fm_psninfo.getItemByCode(StapplyVO.PK_TRNSTYPE).setDisabled(true);		
		fm_psninfo.getItemByCode(StapplyVO.PK_TRNSTYPE).setRequired(false);
		fm_psninfo.getItemByCode(StapplyVO.SREASON).setDisabled(false);
		fm_psninfo.getItemByCode(StapplyVO.SREASON).setRequired(true);
		fm_psninfo.getItemByCode(StapplyVO.EFFECTDATE).setDisabled(false);
		fm_psninfo.getItemByCode(StapplyVO.EFFECTDATE).setRequired(true);
		// 
		fm_psninfo.getItemByCode(StapplyVO.TRIALDAYS).setDisabled(true);		
		fm_psninfo.getItemByCode(StapplyVO.TRIALDAYS).setRequired(false);		
		fm_psninfo.getItemByCode(StapplyVO.TRIAL_UNIT).setDisabled(true);		
		fm_psninfo.getItemByCode(StapplyVO.TRIAL_UNIT).setRequired(false);		
		fm_psninfo.getItemByCode(StapplyVO.TRIALBEGINDATE).setDisabled(true);		
		fm_psninfo.getItemByCode(StapplyVO.TRIALBEGINDATE).setRequired(false);		
		fm_psninfo.getItemByCode(StapplyVO.TRIALENDDATE).setDisabled(true);		
		fm_psninfo.getItemByCode(StapplyVO.TRIALENDDATE).setRequired(false);
		// ͬϢ
		CtrtVO ctrt = getCtrt((StapplyVO) aggvo.getParentVO());
		if (ctrt == null) {
			// µĺͬ¼ǩ//ǩ״̬δǩͬߺͬѾ/ֹҪѡͱ༭
			((StapplyVO) aggvo.getParentVO()).setIsrelease(UFBoolean.FALSE);
			((StapplyVO) aggvo.getParentVO()).setIsend(UFBoolean.FALSE);
			((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.ISRELEASE).setDisabled(true);
			((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.ISEND).setDisabled(true);
		}
        if (TRNConst.TRANSMODE_CROSS_OUT == transMode ) {
            // ,ְHR֯
            ((FormMeta) pm.getAreaMeta("stapply_mng_org")).getItemByCode(StapplyVO.PK_HI_ORG).setDisabled(false);
            ((StapplyVO)aggvo.getParentVO()).setPk_hi_org(null);
        } else {
            // ֯ڡ롢ְ֯ǵǰHR֯
    		((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.PK_HRCM_ORG).setDisabled(true);		
    		((FormMeta) pm.getAreaMeta("stapply_mng_org")).getItemByCode(StapplyVO.PK_HI_ORG).setDisabled(true);
    		((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.ISRELEASE).setDisabled(true);	
    		((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.ISEND).setDisabled(true);	
        }
		// Ƿڵ
     	boolean isapprove = param.getBoolean("isapprove", false);
		if (isapprove) {
             // ڵ㲻޸ҵ
             ((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.TRANSTYPEID).setDisabled(true);
             ((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.BUSINESS_TYPE).setDisabled(true);
        } else {
             ((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.BILL_CODE).setDisabled(true);
        }
		if (isapprove)  {
		    ((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.BILL_CODE).setDisabled(true);
			((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.BUSINESS_TYPE).setDisabled(true);
			((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.TRANSTYPEID).setDisabled(true);
			((FormMeta) pm.getAreaMeta("card")).getItemByCode(StapplyVO.APPLY_DATE).setDisabled(true);
			// ڵ㲻޸Ľֹ
			((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.ISRELEASE).setDisabled(true);
			((FormMeta) pm.getAreaMeta("contract_mng_org")).getItemByCode(StapplyVO.ISEND).setDisabled(true);
        }
		//ҳĬ
		Map result = new HashMap<>();
		result.put("formData",HRNccTemplateUtils.getFormWithArea(HRYFConst.PAGECODE_TRANAPPLY, "card", (SuperVO) aggvo.getParentVO()));
		result.put("isBillCodeEditable",  super.isBillCodeEditable(context));
		result.put(TRNConst.TRNS_OLDINFO_TAB, pm.getAreaMeta(TRNConst.TRNS_OLDINFO_TAB));
		result.put(TRNConst.TRNS_NEWINFO_TAB, pm.getAreaMeta(TRNConst.TRNS_NEWINFO_TAB));
		result.put(TRNConst.TRNS_PSNINFO_TAB, pm.getAreaMeta(TRNConst.TRNS_PSNINFO_TAB));
		result.put("contract_mng_org", pm.getAreaMeta("contract_mng_org"));
		result.put("stapply_mng_org", pm.getAreaMeta("stapply_mng_org"));
		result.put("card", pm.getAreaMeta("card"));
		FormItemMeta psnItemMeta = ((FormMeta)pm.getAreaMeta(TRNConst.TRNS_PSNINFO_TAB)).getItemByCode(StapplyVO.PK_PSNJOB);
		// ѯǰ𼶹ܿģʽ,йܿ
		if(getQuerySeq()){
			psnItemMeta.setRefcode("hrhi/refer/hiref/PsnjobRefTreeGridRef/index");
		}
		return result;
	}
	

}
