package nccloud.web.hrwa.waruleex.action.formula;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import nc.hr.utils.ResHelper;
import nc.ui.pub.formulaparse.FormulaParse;
import nc.vo.pub.BusinessException;
import nc.vo.pub.formulaset.FormulaParseFather;
import nc.vo.wa.pub.WaLoginContext;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.web.container.IRequest;
import nccloud.framework.web.json.JsonFactory;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccFormulaHelper;
import nccloud.web.hrwa.helper.WaLoginContextUtils;
import nccloud.web.hrwa.waruleex.action.formula.pub.TranslateFormula;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * нʷĿ ֤ȷϹʽ,ʽûתת
 * 
 * @author YuCheng
 *
 */
public class WaRuleExFormulaValidateAction extends HRCommonAction {

	@Override
	public <T> Object execute(IRequest request, T para) throws BusinessException {
		ParamUtils param = new ParamUtils(request);
		WaLoginContext context = WaLoginContextUtils.getWaLoginContext(param);
		String formulaStr = param.getString("formulastr", null);// ıʽ

		// ҪݵĶʱֻмĲʹ
		String condition = param.getString("condition", null);
		String formula = param.getString("formula", null);
		// 
		String dynPara= param.getString("dynPara", "");
		if (formulaStr != null) {
			if (StringUtils.isBlank(formula)) {
				// ıʽת
				dynPara = StringUtils.isBlank(dynPara) ? new HRNccFormulaHelper().getCountryPk(formula,formulaStr) : dynPara;
				formula = new TranslateFormula().translateFormula(context, formulaStr, condition, dynPara);
			}

			formula = resetNameOfWaGrade(formulaStr, formula);
			// ԹʾУ
			String[] formulas = splitFormulaText(formula);
			FormulaParseFather f = new FormulaParse("hrwa");
			if (!f.checkExpressArray(formulas)) {
				throw new BusinessException(ResHelper.getString("formulaparse",
						"UPPformulaparse-000057")/* @res "ʽ֤ʧ!" */);
			}
		} else {
			formula = null;
		}
		Map<String, String> resultMap = new HashMap<String, String>();
		resultMap.put("formula", formula);
		resultMap.put("formulaStr", formulaStr);
		return JsonFactory.create().toJson(resultMap);
	}
	
	private String[] splitFormulaText(String formulaText) {
		formulaText = formulaText.replaceAll("\n", "").replaceAll("\t", "").replaceAll(" ", "");
		return formulaText.split(";");
	}
	/**
	 * 20140608 shenliangc нʹʽнʱ׼ʱ༭ʾűԶʾҵԵ⡣
	 * @param formula
	 * @return String
	 */
	public String resetNameOfWaGrade(String formulaStr,String formula) throws BusinessException {
		formula= (!formula.contains(".") && formulaStr.contains(".")) ? formulaStr : formula;
		try {
			if (StringUtils.isEmpty(formula)) {
				return "";
			}
			// Ŀǰ߼ֻ˼򵥹ʽӹʽҪʽȽضϳɶ򵥹ʽд
			// нʹʽֻʹáߡҡӼ򵥹ʽԴΪǽضϹʽ
			// Ȼеõļ򵥹ʽд󽫹ʽء
			// ̰϶ַڸӶȷе⡣
			ArrayList<String> subFormulaList = new ArrayList<String>();
			while (formula.contains("") || formula.contains("")) {
				int splitPosition = getSplitPosition(formula);
				subFormulaList.add(formula.substring(splitPosition));
				formula = formula.substring(0, splitPosition);
			}
			subFormulaList.add(formula);
			// ӹʽֳɶ򵥹ʽɣÿ򵥹ʽֻһ"="
			// ÿ򵥹ʽֱнʱ׼
			String[] subFormulaArray = subFormulaList.toArray(new String[0]);
			for (int i = subFormulaArray.length; i > 0; i--) {
				String subFormula = subFormulaArray[i - 1];
				// ʱʽʽ£
				// [нʱ׼.ܲλн׼<>] = "1001PP1000000000H2FZ"
				// ֵȺұߵнʱ׼еĵǼ
				String fieldCode = "";
				if (subFormula.indexOf("<") > 0 && subFormula.indexOf(">") > 0) {
					fieldCode = subFormula.substring(subFormula.indexOf("<") + 1, subFormula.indexOf(">"));
				}
				String condition = "";
				if (subFormula.indexOf("=") > 0) {
					condition = subFormula.substring(subFormula.indexOf("=") + 1).replace("\"", "").trim();
				}
				String nameOfWaCriterion = "";
				String oldName = "";
				if (subFormula.contains(".") && subFormula.contains("<")) {
					oldName = subFormula.substring(subFormula.indexOf(".") + 1, subFormula.indexOf("<"));
				}
				if (!StringUtils.isEmpty(oldName) && !StringUtils.isEmpty(nameOfWaCriterion)
						&& !oldName.equals(nameOfWaCriterion)) {
					subFormula = subFormula.replace(oldName, nameOfWaCriterion);
					subFormulaArray[i - 1] = subFormula;
				}
			}
		} catch (Exception e) {
			throw new BusinessException(ResHelper.getString("formulaparse",
					"UPPformulaparse-000057")/* @res "ʽ֤ʧ!" */);
		}
		return formula;
	}
	/**
	 * 20140608 shenliangc нʹʽнʱ׼ʱ༭ʾűԶʾҵԵ⡣
	 * ҹʽһҡ򡰻ߡλ
	 * @param formula
	 * @return int
	 */
	private int getSplitPosition(String formula)
	{
	    int lastIndexOfAnd = formula.lastIndexOf("");
	    int lastIndexOfOr = formula.lastIndexOf("");
	    
	    return lastIndexOfAnd > lastIndexOfOr ? lastIndexOfAnd : lastIndexOfOr;
	}

}
