package nccloud.web.hryf.psninfoapprove.action;

import java.util.HashMap;
import java.util.Map;

import nc.itf.hi.IPsndocQryService;
import nc.md.model.IBean;
import nc.vo.hi.psndoc.PsndocAggVO;
import nc.vo.pub.BusinessException;
import nc.vo.pub.BusinessRuntimeException;
import nc.vo.pub.SuperVO;
import nc.vo.uif2.LoginContext;
import nccloud.commons.lang.StringUtils;
import nccloud.framework.service.ServiceLocator;
import nccloud.framework.web.container.IRequest;
import nccloud.web.hr.pub.HRCommonAction;
import nccloud.web.hr.pub.HRNccTemplateUtils;
import nccloud.web.hr.pub.HRNccUtils;
import nccloud.web.hrhi.pub.MetaDataUtils;
import nccloud.web.hrhi.pub.PsndocTempUtils;
import nccloud.web.uapbd.commons.web.ParamUtils;

/**
 * ѯ
 */
public class PsndocSubQueryPKAction extends HRCommonAction {
    @Override
    public <T> Object execute(IRequest request, T para) throws Exception {
        ParamUtils param = new ParamUtils(request);
        LoginContext context = HRNccUtils.getLoginContext(param);
        // hr֯id
        if (StringUtils.isBlank(context.getPk_org())) {
            throw new BusinessRuntimeException("Parameter Error!");
        }
        String tableCode = param.getString("table_code", null);
        if (StringUtils.isBlank(tableCode)) {
            //  
            throw new BusinessRuntimeException("tableCode Parameter Error!");
        }
        String billId = param.getString("billId", null);

        IBean bean = MetaDataUtils.getBeanByName("hrhi", tableCode);
        Class subClass = Class.forName(bean.getFullClassName());
        SuperVO[] subSetVOs = (SuperVO[]) HRNccTemplateUtils.getVOFromGrid(subClass, PsndocTempUtils.getModelStr(param, null));
        if (subSetVOs == null || subSetVOs.length == 0) {
            throw new BusinessException("ûҪϴ");
        }
        String pk = subSetVOs[0].getPrimaryKey();
        Map<String,String> map = new HashMap();
        map.put("subBillId", pk);
        PsndocAggVO psndocAggVO = ServiceLocator.find(IPsndocQryService.class).queryPsndocVOByPk(billId, true, true);
        map.put("psndocName", psndocAggVO.getParentVO().getName());
        return map;
    }
}
